// Copyright(C)SEGA 
#ifndef COLLADA_ANIMATION_H
#define COLLADA_ANIMATION_H

#include "Collada/Resource.h"

namespace Collada {

    class FloatVector;
    class Float2Vector;
    class StringVector;
    class Sampler;
    class XMLElement;

    // Aj[VNX
    class Animation : public Resource {

    public:
        // RXgN^
        Animation();

        // Rs[RXgN^
        Animation( const Animation& a );

        // fXgN^
        ~Animation();

        // XMLݒ
        void toXML( XMLElement* e );

        // ɎAnimationArray
        std::vector< Animation* > mAnimations;

        // Input
        FloatVector* mInput;

        // Output
        FloatVector* mOutput;

        // Interpolation
        StringVector* mInterpolation;

        // InTangent
        Float2Vector* mInTangent;

        // OutTangent
        Float2Vector* mOutTangent;

        // Sampler
        Sampler* mSampler;

        // Channel
        Channel mChannel;

    };

}

#endif // COLLADA_ANIMATION_H
