// Copyright(C)SEGA 
#ifndef	COLLADA_COLLECTION_H
#define COLLADA_COLLECTION_H

#include "Collada/Resource.h"
#include <vector>

namespace Collada {

    class Asset;
    class Camera;
    class Light;
    class Image;
    class Effect;
    class Material;
    class VisualScene;
    class Controller;
    class Geometry;
    class Animation;
    class AnimationClip;
    class Extra;
    class XMLDocument;

    // ColladaCollectionNX
    class Collection : public Resource {

    public:
        // RXgN^
        Collection();

        // fXgN^
        ~Collection();

        // C[W擾
        Image* getImage( const std::string& id );

        // GtFNg擾
        Effect* getEffect( const std::string& id );		

        // }eA擾
        Material* getMaterial( const std::string& id );

        // WIg擾
        Geometry* getGeometry( const std::string& id );

        // XMLɕϊ
        bool toXML( XMLDocument* doc );

        // o
        bool save( const std::string& filename );

        // AZbg
        Asset* mAsset;

        // J
        std::vector< Camera* > mCameras;

        // Cg
        std::vector< Light* > mLights;

        // C[W
        std::vector< Image* > mImages;

        // GtFNg
        std::vector< Effect* > mEffects;

        // }eA
        std::vector< Material* > mMaterials;

        // WIg
        std::vector< Geometry* > mGeometries;

        // rWAV[i炭j
        std::vector< VisualScene* > mVisualScenes;

        // Rg[[
        std::vector< Controller* > mControllers;

        // Aj[V
        std::vector< Animation* > mAnimations;

        // V[
        Scene mScene;

        // extra
        Extra* mExtra;

    };

}

#endif	// COLLADA_COLLECTION_H
