// Copyright(C)SEGA 
#ifndef	COLLADA_CONTROLLER_H
#define	COLLADA_CONTROLLER_H

#include "Collada/Resource.h"
#include <vector>

namespace Collada {

    class MatrixVector;
    class FloatVector;
    class VertexWeights;
    class StringVector;

    // Rg[[ieNXj
    class Controller : public Resource {

    public:
        enum Type {

            Type_SKIN,
            Type_MORPH,			

        };

        // RXgN^
        Controller();

        // fXgN^
        virtual ~Controller();

        // XMLݒ
        virtual void toXML( XMLElement* e );

        // SkinMorph
        Type mType;

        // XMLݒ
        virtual void toXMLDetail( XMLElement* e ) = 0;

        // ΏۃWIg
        std::string mSource;

        // ^[Qbg
        StringVector* mTarget;

        // EFCg
        FloatVector* mWeight;

        // Input
        std::vector< Input > mInputs;

    };

}

#endif	// COLLADA_CONTROLLER_H
