// Copyright(C)SEGA 
#ifndef	COLLADA_GEOMETRY_H
#define	COLLADA_GEOMETRY_H

#include "Collada/Resource.h"
#include <vector>

namespace Collada {

    class Float2Vector;
    class Float3Vector;
    class ColorVector;
    class PolyList;
    class Triangles;
    class Vertices;
    class StructVector;
    class Extra;
    class XMLElement;

    // WIg
    class	Geometry : public Resource {

    public:
        // RXgN^
        Geometry() : mExtra( NULL ) {}

        // fXgN^
        ~Geometry();

        // ʒu擾
        Float3Vector* getPosition( const std::string& id );

        // ʒu擾(VerticesoR)
        Float3Vector* getPositionByVertices( const std::string& id );		

        // @擾
        Float3Vector* getNormal( const std::string& id );

        // J[擾
        ColorVector* getColor( const std::string& id );

        // ڐ擾(Geometryt)
        Float3Vector* getGeoTangent( const std::string& id );

        // ]@擾(Geometryt)
        Float3Vector* getGeoBinormal( const std::string& id );

        // UV擾(id)
        Float2Vector* getUV( const std::string& id );

        // ڐ擾(UVP)
        Float3Vector* getTangent( const std::string& id );				

        // ]@擾(UVP)
        Float3Vector* getBinormal( const std::string& id );

        // _(Vertices)擾
        Vertices* getVertices( const std::string& id );

        // source擾(id)
        StructVector* getSource( const std::string& id );

        // source擾(index)
        StructVector* getSource( const int index );		

        // source̐擾
        int getSourceNumber() const;		

        // XMLݒ
        void toXML( XMLElement* e );

        // ʒu
        std::vector< Float3Vector* > mPositions;

        // @
        std::vector< Float3Vector* > mNormals;

        // J[()
        std::vector< ColorVector* > mColors;

        // ڐݒ(Geometryt)
        std::vector< Float3Vector* > mGeoTangents;

        // ]@ݒ(Geometryt)
        std::vector< Float3Vector* > mGeoBinormals;

        // UV()
        std::vector< Float2Vector* > mUVs;

        // ڐ(UVP)
        std::vector< Float3Vector* > mTangents;

        // ]@(UVP)
        std::vector< Float3Vector* > mBinormals;

        // _
        std::vector< Vertices* > mVertices;

        // polylist
        std::vector< PolyList* > mPolyLists;

        // triangles
        std::vector< Triangles* > mTriangles;

        // extra
        Extra* mExtra;		
    };

}

#endif	// COLLADA_GEOMETRY_H
