// Copyright(C)SEGA 
#ifndef	COLLADA_NODE_H
#define	COLLADA_NODE_H

#include "Collada/Resource.h"
#include <vector>
#include <string>

namespace Collada {

    class Extra;    
    class InstanceGeometry;
    class XMLElement;

    // m[h
    class	Node : public Resource {

    public:
        // m[h̎
        enum NodeType {

            NodeType_JOINT,
            NodeType_NODE,

        };

        // QƐ̎
        enum InstanceType {

            InstanceType_NONE,
            InstanceType_GEOMETRY,
            InstanceType_LIGHT,
            InstanceType_CAMERA,			

        };

        // RXgN^
        Node();

        // fXgN^
        ~Node();

        // NodeType𕶎ŕԂ
        const char* nodeTypeStr( const Node::NodeType nodeType );

        // XMLݒ
        void toXML( XMLElement* e );

        // QƐ̎
        InstanceType mInstanceType;

        // m[h̎
        NodeType mNodeType;

        // QƐ悪WIg̏ꍇ
        InstanceGeometry* mInstanceGeometry;

        // QƐ悪Cg̏ꍇ
        InstanceLight* mInstanceLight;

        // QƐ悪J̏ꍇ
        InstanceCamera* mInstanceCamera;		

        // ړ
        Float3 mTranslate;

        // ]
        Float4 mRotationX;
        Float4 mRotationY;
        Float4 mRotationZ;

        // XP[
        Float3 mScale;

        // qm[hiQƁj
        std::vector< Node* > mChildren;

        // extra
        Extra* mExtra;

    };

}

#endif	// COLLADA_NODE_H
