// Copyright(C)SEGA 
#ifndef	COLLADA_STRUCT_VECTOR_H
#define	COLLADA_STRUCT_VECTOR_H

#include "Collada/Resource.h"
#include <vector>

namespace Collada {

    class Accessor;
    class XMLElement;

    // Vectorn̐eNXiOtj
    class	StructVector : public Resource {

    public:
        // RXgN^
        StructVector() : mAccessor(NULL), mArrayTag("float_array") {}

        // Rs[RXgN^
        StructVector( const StructVector& sv );

        // fXgN^
        virtual ~StructVector();

        // XMLݒ
        void toXML( XMLElement* e );

        // Svf̐擾(Colladacountɑ
        // Float310ꍇ30		
        virtual int getCount() const = 0;

        // vf̒PʐԂ
        // Float3̏ꍇ3
        virtual int getElementNumber() { return 1; }

        // z𕶎ɕϊ
        virtual void arrayToString( std::string* ret ) = 0;

        // z̃^O̖O
        std::string mArrayTag;

        // z̖O
        std::string mArrayName;

        // Accessor
        Accessor* mAccessor;

    };

    // Int̃xN^
    class	IntVector : public StructVector {

    public:
        // RXgN^
        IntVector();

        // z̗vf擾(int̑)
        int getCount() const;

        // vf̒PʐԂ
        int getElementNumber() { return 1; }

        // z𕶎ɕϊ
        void arrayToString( std::string* ret );

        // vf
        std::vector< int > mElement;

    };

    // Float̃xN^
    class	FloatVector : public StructVector {

    public:
        // RXgN^
        FloatVector();

        // z̗vf擾(float̑)
        int getCount() const;

        // vf̒PʐԂ
        int getElementNumber() { return 1; }		

        // z𕶎ɕϊ
        void arrayToString( std::string* ret );

        // vf
        std::vector< float > mElement;

    };

    // Float2̃xN^
    class	Float2Vector : public StructVector {

    public:
        // RXgN^
        Float2Vector();

        // vf擾
        void elementArray( std::vector< Float2 >* element ) const;

        // z̗vf擾(float̑)
        int getCount() const;

        // vf̒PʐԂ
        int getElementNumber() { return 2; }				

        // z𕶎ɕϊ
        void arrayToString( std::string* ret );

        // vf
        std::vector< Float2 > mElement;

    };


    // Float3̃xN^iOtj    
    class	Float3Vector : public StructVector {

    public:
        // RXgN^
        Float3Vector();

        // z̗vf擾(float̑)
        int getCount() const;

        // vf̒PʐԂ
        int getElementNumber() { return 3; }						

        // z𕶎ɕϊ
        void arrayToString( std::string* ret );

        // vf
        std::vector< Float3 > mElement;

    };

    // J[̃xN^iOtj
    class	ColorVector : public StructVector {

    public:
        // RXgN^
        ColorVector();

        // z̗vf擾(float̑)
        int getCount() const;

        // vf̒PʐԂ
        int getElementNumber() { return 4; }								

        // z𕶎ɕϊ
        void arrayToString( std::string* ret );

        // vf
        std::vector< Color > mElement;

    };

    // ̃xN^iOtj
    class	StringVector : public StructVector {

    public:
        // RXgN^
        StringVector();

        // z̗vf擾(string̑)
        int getCount() const;

        // vf̒PʐԂ
        int getElementNumber() { return 1; }										

        // z𕶎ɕϊ
        void arrayToString( std::string* ret );

        // vf
        std::vector< std::string > mElement;

    };

    // Matrix(4x4)̃xN^iOtj
    class	MatrixVector : public StructVector {

    public:
        // RXgN^
        MatrixVector();

        // z̗vf擾(float̑)
        int getCount() const;

        // vf̒PʐԂ
        int getElementNumber() { return 16; }												

        // z𕶎ɕϊ
        void arrayToString( std::string* ret );

        // vf
        std::vector< Matrix > mElement;

    };

}

#endif	// COLLADA_STRUCT_VECTOR_H
