// Copyright(C)SEGA 
#ifndef	COLLADA_TECHNIQUE_H
#define COLLADA_TECHNIQUE_H

#include "Collada/Resource.h"

namespace Collada {

    class Texture;
    class ColorOrTextureOrFloat;
    class XMLElement;

    // eNjbN̐eNX
    class Technique : public Resource {

    public:
        // RXgN^
        Technique();

        // Rs[RXgN^
        Technique( const Technique& t );

        // fXgN^
        virtual ~Technique();

        // Collada̎dlɍ킹āAJ[ƃeNX`͂ǂ炩ĂȂ悤ɂB

        // diffuseȂǂɃeNX`ݒ
        void addTexture( const std::string& attrName, Texture* texture );

        // diffuseȂǂɃJ[ݒ
        void addColor( const std::string&, const Color& color );

        // J[ǉ(Attributet)
        void addColor( const std::string& attrName, const Color& color, const Attribute& attribute );

        // shininessȂǂfloatlݒ
        void addFloat( const std::string& attrName, const float value );

        // ColorOrTextureOrFloat擾
        ColorOrTextureOrFloat* colorOrTextureOrFloat( const std::string& name );

        // XMLݒ
        void toXML( XMLElement* e );

        // J[oreNX`orFloat̃XgiQƁj
        std::vector< ColorOrTextureOrFloat* > mColorOrTextureOrFloats;

        // J[oreNX`orFloat̃Xg(Extra)iQƁj
        std::vector< ColorOrTextureOrFloat* > mColorOrTextureOrFloatsExtra;		

    protected:
        // t\ȑ`FbN
        virtual bool isAcceptable( const std::string& attrName ) = 0;

        // ColorOrTextureOrFloatǉ
        bool addColorOrTextureOrFloat( ColorOrTextureOrFloat* ctf );

        // ColorOrTextureOrFloatǉ(Extra)
        bool addColorOrTextureOrFloatExtra( ColorOrTextureOrFloat* ctf );		

    };

    // Constant
    class Constant : public Technique {

    public:
        // RXgN^
        Constant();

    private:
        // t\ȑ`FbN
        bool isAcceptable( const std::string& attrName );

        // ֎~                
        void operator=( const Constant& );         
    };

    // Lambert
    class Lambert : public Technique {

    public:
        // RXgN^
        Lambert();

    private:        
        // t\ȑ`FbN
        bool isAcceptable( const std::string& attrName );        

        // ֎~                
        void operator=( const Lambert& ); 
    };

    // Phong
    class Phong : public Technique {

    public:
        // RXgN^
        Phong();

    private:        
        // t\ȑ`FbN
        bool isAcceptable( const std::string& attrName );                

        // ֎~        
        void operator=( const Phong& );         
    };

    // Blinn
    class Blinn : public Technique {

    public:
        // RXgN^
        Blinn();

    private:        
        // t\ȑ`FbN
        bool isAcceptable( const std::string& attrName );                        

        // ֎~        
        void operator=( const Blinn& );         
    };

}

#endif // COLLADA_COMMON_TECHNIQUE_H

