// Copyright(C)SEGA 
#ifndef	COLLADA_TEST_H
#define COLLADA_TEST_H

namespace Collada {

    class InstanceGeometry;
    class VisualScene;
    class Node;
    class Collection;
    class Geometry;
    class PolyList;
    class Triangles;
    class Material;
    class Effect;
    class Technique;
    class Image;
    class Profile;
    class Texture;
    class StructVector;
    class IntVector;
    class SkinController;
    class MorphController;

    // ColladãeXgsNX
    class Test {

    public:
        // Ă邩`FbN(Collection)
        static bool testCollection( Collection* collection );

        // Ă邩`FbN(MorphController)
        static bool testMorphController( MorphController* controller, Collection* collection );

        // Ă邩`FbN(SkinController)
        static bool testSkinController( SkinController* controller, Collection* collection );		

        // Ă邩`FbN(VisualScene)
        static bool testVisualScene( Collada::VisualScene* visualScene,
            Collection* collection );

        // Ă邩`FbN(Node)
        static bool testNode( Node* node, Collection* collection );

        // Ă邩`FbN(InstanceGeometry)
        static bool testInstanceGeometry( InstanceGeometry* instanceGeometry,
            Collection* collection );

        // Ă邩`FbN(Geometry)
        static bool testGeometry( Geometry* geometry, const std::string& materialName, Collection* collection );

        // Ă邩`FbN(PolyList)
        static bool testPolyList( PolyList* polylist, Geometry* geometry, Collection* collection );

        // Ă邩`FbN(Triangles)
        static bool testTriangles( Triangles* triangles, Geometry* geometry, Collection* collection );

        // Ă邩`FbN(Index)		
        static bool testIndex( StructVector* v, IntVector* indexVector );

        // Ă邩`FbN(Geometrysource)    	
        static bool testGeometrySource( Geometry* geometry, 
            IntVector* indexVector,
            //Triangles* triangles,
            const Input& input );

        // Ă邩`FbN(Input)
        static bool testInput( const Input& input, Geometry* geometry );

        // Ă邩`FbN(Material)        
        static bool testMaterial( Material* material, Geometry* geometry, Collection* collection );

        // Ă邩`FbN(Effect)            
        static bool testEffect( Effect* effect, Material* material, Geometry* geometry, Collection* collection );

        // Ă邩`FbN(Technique)                
        static bool testTechnique( Technique* technique, 
            Material* material,
            Profile* profile, 
            Geometry* geometry, 
            Collection* collection );

        // Ă邩`FbN(Texture)                    
        static bool testTexture( Texture* texture,
            Material* material,
            Profile* profile,
            Geometry* geometry, 
            Collection* collection );
    };
}

#endif // COLLADA_TEST_H