// Copyright(C)SEGA 
#ifndef	COLLADA_VARIANT_H
#define COLLADA_VARIANT_H

#include "Collada/Struct.h"

namespace Collada {

    // @AgNX
    class	Variant {

    public:
        // @Aǧ^    
        enum VariantType {

            VariantType_FLOAT,
            VariantType_INT,
            VariantType_BOOL,            
            VariantType_STRING,
            VariantType_COLOR,

        };

        // RXgN^
        Variant();

        // Float̒lݒ
        void setFloatValue( const float value );

        // Int̒lݒ
        void setIntValue( const int value );

        // Bool̒lݒ
        void setBoolValue( const bool value );

        // ̒lݒ
        void setStringValue( const std::string& value );

        // J[̒lݒ
        void setColorValue( const Color& value );

        // operator==
        bool operator==( const Variant& v ) const;

        // operator!=
        bool operator!=( const Variant& v ) const;		

        // @Aǧ^
        VariantType mVariantType;

        // Float̒l
        float	mFloatValue;

        // Int̒l        
        int	mIntValue;

        // Bool̒l
        bool mBoolValue;

        // ̒l                
        std::string mStringValue;

        // J[̒l                        
        Color mColorValue;

    };

}

#endif	// COLLADA_VARIANT_H
