// Copyright(C)SEGA 
#include "Collada/Accessor.h"
#include "Collada/XML.h"

namespace Collada {

    // XMLݒ
    void Accessor::toXML( XMLElement* e )
    {
        e->mName = "accessor";
        e->mAttributes.push_back( new XMLAttribute( "source", mSource ) );
        e->mAttributes.push_back( new XMLAttribute( "count", mCount ) );
        e->mAttributes.push_back( new XMLAttribute( "stride", mStride ) );

        {
            const int paramNumber = mParams.size();
            for( int i=0; i<paramNumber; i++ ) {

                XMLElement* paramE = new XMLElement();

                paramE->mName = "param";                
                paramE->mAttributes.push_back( new XMLAttribute( "name", mParams[ i ].mName ) );
                paramE->mAttributes.push_back( new XMLAttribute( "type", mParams[ i ].mType ) );

                e->mChildren.push_back( paramE );

            }
        }
    }
}
