// Copyright(C)SEGA 
#include "Collada/Asset.h"
#include "Collada/Contributor.h"
#include "Collada/Util.h"
#include "Collada/Macro.h"
#include "Collada/XML.h"

#include <sstream>
using namespace std;

namespace Collada {

    // fXgN^
    Asset::~Asset()
    {
        SAFE_DELETE( mContributor );
    }

    // UpAxis𕶎Ŏ擾
    const char* Asset::upAxisStr( const UpAxis upAxis )
    {
        switch( upAxis ) {

        case UpAxis_X_UP:
            return "X_UP";

        case UpAxis_Y_UP:
            return "Y_UP";

        case UpAxis_Z_UP:
            return "Z_UP";

        default:
            return "UNKNOWN";
            break;
        }

        return "";
    }

    // XMLݒ
    void Asset::toXML( XMLElement* e )
    {
        e->mName = "asset";
        {
            // contributor
            XMLElement* childE = new XMLElement();
            mContributor->toXML( childE );
            e->mChildren.push_back( childE );

            // created
            XMLElement* createdE = new XMLElement();
            setStringXML( "created", mCreated, createdE );
            e->mChildren.push_back( createdE );

            // modified
            XMLElement* modifiedE = new XMLElement();
            setStringXML( "modified", mModified, modifiedE );
            e->mChildren.push_back( modifiedE );

            // unit
            ostringstream ss;
            ss << mUnit.mMeter;
            string meter = ss.str();            

            XMLElement* unitE = new XMLElement();
            unitE->mName = "unit";            
            unitE->mAttributes.push_back( new XMLAttribute( "name", mUnit.mName ) );
            unitE->mAttributes.push_back( new XMLAttribute( "meter", meter ) );
            e->mChildren.push_back( unitE );

        }
    }

};
