// Copyright(C)SEGA 
#include "Collada/ColorOrTextureOrFloat.h"
#include "Collada/Texture.h"
#include "Collada/XML.h"

namespace Collada {

    // RXgN^
    ColorOrTextureOrFloat::ColorOrTextureOrFloat() :
mType( Type_COLOR ),
mTexture( NULL ),
mFloat( 0.0f )
{
}

// fXgN^
ColorOrTextureOrFloat::~ColorOrTextureOrFloat() 
{
    SAFE_DELETE( mTexture );
}

// XMLݒ
void ColorOrTextureOrFloat::toXML( XMLElement* e )
{
    e->mName = mName;

    const int attributeNumber = mAttribute.size();
    for( int i=0; i<attributeNumber; i++ ) {

        e->mAttributes.push_back( new XMLAttribute( mAttribute[ i ].mName, mAttribute[ i ].mValue ) );

    }

    {        
        XMLElement* valueE = new XMLElement();

        switch( mType ) {

            case Type_COLOR:
                setColorXML( "color", mColor, valueE );
                break;

            case Type_TEXTURE:
                mTexture->toXML( valueE );
                break;

            case Type_FLOAT:
                setFloatXML( "float", mFloat, valueE );
                break;

        }

        e->mChildren.push_back( valueE );

    }

}

};

