// Copyright(C)SEGA 
#include "Collada/Effect.h"
#include "Collada/Profile.h"
#include "Collada/Technique.h"
#include "Collada/Macro.h"
#include "Collada/Texture.h"
#include "Collada/XML.h"

#include <string>
using namespace std;

namespace Collada {

    // RXgN^
    Effect::Effect() : mProfile( NULL )
    {
    }

    // fXgN^
    Effect::~Effect()
    {
        SAFE_DELETE( mProfile );
    }

    // vt@C擾
    Profile* Effect::profile()
    {
        return mProfile;
    }

    // XMLݒ
    void Effect::toXML( XMLElement* e )
    {
        e->mName = "effect";        
        e->mAttributes.push_back( new XMLAttribute( "id", mId ) );

        if( mProfile ) {

            XMLElement* childE = new XMLElement();
            mProfile->toXML( childE );
            e->mChildren.push_back( childE );

        }

    }

}
