// Copyright(C)SEGA 
#include "Collada/Extra.h"
#include "Collada/ExtraAttribute.h"
#include "Collada/Variant.h"
#include "Collada/Util.h"
#include "Collada/XML.h"

using namespace std;

namespace Collada {

    // RXgN^
    Extra::Extra()
    {
    }

    // Rs[RXgN^
    Extra::Extra( const Extra& e ) : Resource( e )
    {
        mProfile = e.mProfile;

        const int num = e.mExtraAttributes.size();
        for( int i=0; i<num; i++ ) {        

            ExtraAttribute* ea = new ExtraAttribute( *e.mExtraAttributes[ i ] );
            mExtraAttributes.push_back( ea );

        }
    }

    // fXgN^
    Extra::~Extra()
    {
        const int extraAttributeNumber = mExtraAttributes.size();
        for( int i=0; i<extraAttributeNumber; i++ ) {

            SAFE_DELETE( mExtraAttributes[ i ] );

        }
        mExtraAttributes.clear();
    }


    // gAgr[gǉ
    bool Extra::addExtraAttribute( ExtraAttribute* ea )
    {
        // Ȍd͋Ag܂ꍇ͒ǉłȂ
        vector< ExtraAttribute* > extraAttributeArray;

        // Ov̂
        getExtraAttribute( ea->mId, &extraAttributeArray );

        // Ô̂ǉł
        if( extraAttributeArray.size() == 0 ) {		

            mExtraAttributes.push_back( ea );
            return true;

        }

        // Agr[gSr
        bool find = false;
        const int extraAttributeNumber = extraAttributeArray.size();
        for( int i=0; i<extraAttributeNumber; i++ ) {

            if( *extraAttributeArray[ i ] == *ea ) {

                find = true;
                break;

            }

        }

        // Agr[gȂǉł
        if( !find ) {

            mExtraAttributes.push_back( ea );
            return true;

        }
        else {

            return false;

        }

    }

    // gAgr[gǉ(ȈՐݒ)
    void Extra::addExtraAttributeFloat( const string& attribute, const float value )
    {
        Collada::ExtraAttribute* extraAttribute = new Collada::ExtraAttribute;
        extraAttribute->mId = attribute;        		
        extraAttribute->mName = attribute;        
        extraAttribute->mValue = new Collada::Variant();
        extraAttribute->mValue->setFloatValue( value );

        mExtraAttributes.push_back( extraAttribute );
    }

    // gAgr[gǉ(ȈՐݒ)
    void Extra::addExtraAttributeString( const string& attribute, const string& value )
    {
        Collada::ExtraAttribute* extraAttribute = new Collada::ExtraAttribute;
        extraAttribute->mId = attribute;        		
        extraAttribute->mName = attribute;        
        extraAttribute->mValue = new Collada::Variant();
        extraAttribute->mValue->setStringValue( value );

        mExtraAttributes.push_back( extraAttribute );        
    }

    // gAgr[gǉ(ȈՐݒ)
    void Extra::addExtraAttributeInt( const string& attribute, const int value )
    {
        Collada::ExtraAttribute* extraAttribute = new Collada::ExtraAttribute;
        extraAttribute->mId = attribute;        		
        extraAttribute->mName = attribute;        
        extraAttribute->mValue = new Collada::Variant();
        extraAttribute->mValue->setIntValue( value );

        mExtraAttributes.push_back( extraAttribute );        
    }

    // gAgr[gǉ(ȈՐݒ)
    void Extra::addExtraAttributeBool( const string& attribute, const bool value )
    {
        Collada::ExtraAttribute* extraAttribute = new Collada::ExtraAttribute;
        extraAttribute->mId = attribute;        		
        extraAttribute->mName = attribute;        
        extraAttribute->mValue = new Collada::Variant();
        extraAttribute->mValue->setBoolValue( value );

        mExtraAttributes.push_back( extraAttribute );        
    }

    // gAgr[gǉ(ȈՐݒ)
    void Extra::addExtraAttributeColor( const string& attribute, const Color& value )
    {
        Collada::ExtraAttribute* extraAttribute = new Collada::ExtraAttribute;
        extraAttribute->mId = attribute;		
        extraAttribute->mName = attribute;
        extraAttribute->mValue = new Collada::Variant();
        extraAttribute->mValue->setColorValue( value );

        mExtraAttributes.push_back( extraAttribute );        
    }

    // gAgr[g擾(vector)
    void Extra::getExtraAttribute( const string& id, vector< ExtraAttribute* >* extraAttributeArray )
    {
        extraAttributeArray->clear();

        const int num = mExtraAttributes.size();
        for( int i=0; i<num; i++ ) {

            ExtraAttribute* cfExtraAttribute = mExtraAttributes[ i ];
            if( id == cfExtraAttribute->mId ) {

                extraAttributeArray->push_back( cfExtraAttribute );

            }

        }
    }

    // XMLݒ
    void Extra::toXML( XMLElement* e )
    {
        e->mName = "extra";        
        {
            XMLElement* techniqueE = new XMLElement();            
            techniqueE->mName = "technique";            
            techniqueE->mAttributes.push_back( new XMLAttribute( "profile", mProfile ) );
            e->mChildren.push_back( techniqueE );
            {
                const int extraAttributeNumber = mExtraAttributes.size();
                for( int i=0; i<extraAttributeNumber; i++ ) {

                    XMLElement* extraAttributeE = new XMLElement();
                    mExtraAttributes[ i ]->toXML( extraAttributeE );
                    techniqueE->mChildren.push_back( extraAttributeE );

                }
            }
        }
    }

}
