// Copyright(C)SEGA 
#include "Collada/Light.h"
#include "Collada/Util.h"
#include "Collada/XML.h"

namespace Collada {

    // XMLݒ
    void Light::toXML( XMLElement* e )
    {
        e->mName = "light";		
        e->mAttributes.push_back( new XMLAttribute( "id", mId ) );
        e->mAttributes.push_back( new XMLAttribute( "name", mName ) );

        XMLElement* techniqueCommonE = new XMLElement();
        e->mChildren.push_back( techniqueCommonE );
        {
            techniqueCommonE->mName = "technique_common";	

            XMLElement* techniqueE = new XMLElement();
            techniqueCommonE->mChildren.push_back( techniqueE );
            {
                switch( mType ) {

                case LightType_DIRECTIONAL:
                    techniqueE->mName = "directional";
                    break;

                case LightType_POINT:
                    techniqueE->mName = "point";
                    break;			

                case LightType_SPOT:
                    techniqueE->mName = "spot";
                    break;

                }

                XMLElement* colorE = new XMLElement();
                techniqueE->mChildren.push_back( colorE );	
                setColorXML( "color", mColor, colorE );
            }

        }			

    }
}
