// Copyright(C)SEGA 
#include "Collada/Material.h"
#include "Collada/Extra.h"
#include "Collada/Util.h"
#include "Collada/XML.h"

namespace Collada {

    // fXgN^
    Material::~Material()
    {
        SAFE_DELETE( mExtra );
    }

    // XMLݒ
    void Material::toXML( XMLElement* e )
    {
        e->mName = "material";        
        e->mAttributes.push_back( new XMLAttribute( "id", mId ) );
        e->mAttributes.push_back( new XMLAttribute( "name", mName ) );        
        {
            // instance_effect
            XMLElement* instanceEffectE = new XMLElement();
            instanceEffectE->mName = "instance_effect";            
            instanceEffectE->mAttributes.push_back( new XMLAttribute( "url", mInstanceEffect ) );
            e->mChildren.push_back( instanceEffectE );

            // extra
            if( mExtra ) {

                XMLElement* extraE = new XMLElement();
                mExtra->toXML( extraE );
                e->mChildren.push_back( extraE );

            }
        }
    }

}
