// Copyright(C)SEGA 
#include "Collada/MorphController.h"
#include "Collada/Macro.h"
#include "Collada/StructVector.h"
#include "Collada/Util.h"
#include "Collada/VertexWeights.h"
#include "Collada/XML.h"

namespace Collada {

    // RXgN^
    MorphController::MorphController()
    {
        mType = Type_MORPH;
    }

    // XMLݒ
    void MorphController::toXMLDetail( XMLElement* e )
    {
        e->mName = "morph";		
        e->mAttributes.push_back( new XMLAttribute( "source", mSource ) );				
        {
            // target
            XMLElement* targetE = new XMLElement();
            mTarget->toXML( targetE );
            e->mChildren.push_back( targetE );

            // EFCg
            XMLElement* weightE = new XMLElement();
            mWeight->toXML( weightE );
            e->mChildren.push_back( weightE );

            // target
            if( mInputs.size() != 0 ) { 

                XMLElement* targetsE = new XMLElement();
                {
                    targetsE->mName = "targets";					

                    const int inputNumber = mInputs.size();
                    for( int i=0; i<inputNumber; i++ ) {

                        XMLElement* inputE = new XMLElement();
                        {
                            inputE->mName = "input";
                            inputE->mAttributes.push_back( new XMLAttribute( "semantic", Util::getSemanticStr( mInputs[ i ].mSemantic ) ) );
                            inputE->mAttributes.push_back( new XMLAttribute( "source", mInputs[ i ].mSource ) );
                        }
                        targetsE->mChildren.push_back( inputE );

                    }

                }
                e->mChildren.push_back( targetsE );

            }

        }

    }

}

