// Copyright(C)SEGA 
#include "Collada/PolyList.h"
#include "Collada/Util.h"
#include "Collada/StructVector.h"
#include "Collada/Macro.h"
#include "Collada/XML.h"

#include <sstream>
using namespace std;

namespace Collada {

    // fXgN^
    PolyList::~PolyList()
    {
        const int indexNumber = mIndices.size();
        for( int i=0; i<indexNumber; i++ ) {

            SAFE_DELETE( mIndices[ i ] );

        }        
    }

    // XMLݒ
    void PolyList::toXML( XMLElement* e )
    {
        e->mName = "polylist";
        e->mAttributes.push_back( new XMLAttribute( "material", mMaterial ) );
        e->mAttributes.push_back( new XMLAttribute( "count", (int)mVCounts.size() ) );
        {
            // input
            const int inputNumber = mInputs.size();
            for( int i=0; i<inputNumber; i++ ) {

                XMLElement* inputE = new XMLElement();
                inputE->mName = "input";

                // texcoord̂Ƃseto炵
                if( mInputs[ i ].mSemantic == Semantic_TEXCOORD ) {

                    inputE->mAttributes.push_back( new XMLAttribute( "semantic", Util::getSemanticStr( mInputs[ i ].mSemantic ) ) );
                    inputE->mAttributes.push_back( new XMLAttribute( "source", mInputs[ i ].mSource ) );
                    inputE->mAttributes.push_back( new XMLAttribute( "offset", mInputs[ i ].mOffset ) );
                    inputE->mAttributes.push_back( new XMLAttribute( "set", mInputs[ i ].mSet ) );

                }
                else {

                    inputE->mAttributes.push_back( new XMLAttribute( "semantic", Util::getSemanticStr( mInputs[ i ].mSemantic ) ) );
                    inputE->mAttributes.push_back( new XMLAttribute( "source", mInputs[ i ].mSource ) );
                    inputE->mAttributes.push_back( new XMLAttribute( "offset", mInputs[ i ].mOffset ) );

                }
                e->mChildren.push_back( inputE );

            }

            // vcount
            {
                ostringstream ss;
                const int vcountNumber = mVCounts.size();
                for( int i=0; i<vcountNumber; i++ ) {

                    ss << mVCounts[ i ] << " ";

                }
                XMLElement* vcountE = new XMLElement();
                {
                    vcountE->mName = "vcount";
                    vcountE->mValue = ss.str();
                }
                e->mChildren.push_back( vcountE );
            }

            // CfbNX(p)
            // offsetƂɕĎ
            {
                ostringstream ss;

                if( mIndices.size() != 0 ) {

                    const size_t num = mIndices[ 0 ]->getCount();

                    for( unsigned i=0; i<num; i++ ) {

                        const int pNumber = mIndices.size();
                        for( int pp=0; pp<pNumber; pp++ ) {

                            ss << mIndices[ pp ]->mElement[ i ] << " ";

                        }

                    }

                }
                XMLElement* pE = new XMLElement();
                {
                    pE->mName = "p";
                    pE->mValue = ss.str();
                }
                e->mChildren.push_back( pE );
            }
        }

    }

}
