// Copyright(C)SEGA 
#include "Collada/Sampler.h"
#include "Collada/Util.h"
#include "Collada/Macro.h"
#include "Collada/XML.h"

namespace Collada {

    // XMLݒ
    void Sampler::toXML( XMLElement* e )
    {
        e->mName = "sampler";        
        e->mAttributes.push_back( new XMLAttribute( "id", mId ) );
        {
            // input
            const int inputNumber = mInputs.size();
            for( int i=0; i<inputNumber; i++ ) {

                XMLElement* inputE = new XMLElement();

                inputE->mName = "input";                
                inputE->mAttributes.push_back( new XMLAttribute( "semantic", Util::getSemanticStr( mInputs[ i ].mSemantic ) ) );
                inputE->mAttributes.push_back( new XMLAttribute( "source", mInputs[ i ].mSource ) );

                e->mChildren.push_back( inputE );

            }

        }

    }
}
