// Copyright(C)SEGA 
#include "Collada/Texture.h"
#include "Collada/Extra.h"
#include "Collada/Util.h"
#include "Collada/XML.h"

namespace Collada {

    // RXgN^
    Texture::Texture() : mExtra(NULL)
    {
    }

    // Rs[RXgN^
    Texture::Texture( const Texture& t ) : mExtra( NULL ) , Resource( t )
    {
        mTexture = t.mTexture;
        mTexcoord = t.mTexcoord;

        // ȑÔ͍̂폜
        delete( mExtra );
        mExtra = NULL;

        if( t.mExtra ) {

            mExtra = new Extra( *t.mExtra );

        }
    }

    // fXgN^
    Texture::~Texture()
    {
        SAFE_DELETE( mExtra );
    }

    // XMLݒ
    void Texture::toXML( XMLElement* e )
    {
        e->mName = "texture";        
        e->mAttributes.push_back( new XMLAttribute( "texture", mTexture ) );
        e->mAttributes.push_back( new XMLAttribute( "texcoord", mTexcoord ) );
        {
            if( mExtra ) {

                XMLElement* extraE = new XMLElement();
                mExtra->toXML( extraE );
                e->mChildren.push_back( extraE );

            }            
        }

    }

}
