// Copyright(C)SEGA 
#include "Collada/Util.h"
#include "Collada/Node.h"
#include "Collada/VisualScene.h"
#include "Collada/Collection.h"
#include "Collada/Technique.h"
#include "Collada/InstanceGeometry.h"
#include "Collada/ColorOrTextureOrFloat.h"
#include "Collada/MorphController.h"
#include "Collada/Geometry.h"

using namespace std;

namespace Collada {

    // Semantic𕶎ŕԂ
    string Util::getSemanticStr( const Semantic s )
    {
        switch( s ) {
        case Semantic_BINORMAL:
            return "BINORMAL";
        case Semantic_COLOR:
            return "COLOR";
        case Semantic_CONTINUITY:
            return "CONTINUITY";
        case Semantic_IMAGE:
            return "IMAGE";
        case Semantic_IN_TANGENT:
            return "IN_TANGENT";
        case Semantic_INPUT:
            return "INPUT";
        case Semantic_INTERPOLATION:
            return "INTERPOLATION";
        case Semantic_INV_BIND_MATRIX:
            return "INV_BIND_MATRIX";
        case Semantic_JOINT:
            return "JOINT";
        case Semantic_LINEAR_STEPS:
            return "LINEAR_STEPS";
        case Semantic_MORPH_TARGET:
            return "MORPH_TARGET";
        case Semantic_MORPH_WEIGHT:
            return "MORPH_WEIGHT";
        case Semantic_NORMAL:
            return "NORMAL";
        case Semantic_OUTPUT:
            return "OUTPUT";
        case Semantic_OUT_TANGENT:
            return "OUT_TANGENT";
        case Semantic_POSITION:
            return "POSITION";
        case Semantic_TANGENT:
            return "TANGENT";
        case Semantic_TEXBINORMAL:
            return "TEXBINORMAL";
        case Semantic_TEXCOORD:
            return "TEXCOORD";
        case Semantic_TEXTANGENT:
            return "TEXTANGENT";
        case Semantic_UV:
            return "UV";
        case Semantic_VERTEX:
            return "VERTEX";
        case Semantic_WEIGHT:
            return "WEIGHT";
        }

        return "";

    }

    // #tsourceidɕϊ
    // i擪#Ƃ邾j
    void Util::sourceToId( const std::string& s, string* ret )
    {		
        if( s.size() < 2 || s[ 0 ] != '#' ) {

            // ȂƂ͂̂܂ܕԂ
            (*ret) = s;
            return;

        }

        //ret->set( s+1, rs.size()-1 );
        *ret = s.substr( 1, s.size()-1 );
    }

    // NodeċAIɌ(Node)
    Node* Util::findNode( Node* node, const string& nodeId ) {

        const int childNumber = node->mChildren.size();
        for( int i=0; i<childNumber; i++ ) {

            Node* childNode = node->mChildren[ i ];
            if( childNode->mId == nodeId ) {

                return childNode;

            }

            Node* find = findNode( childNode, nodeId );
            if( find ) {

                return find;

            }

        }

        return NULL;
    }

    // NodeċAIɌ(VisualScene)
    Node* Util::findNode( VisualScene* visualScene, const string& nodeId ) {

        // [gɂm[h𒲂ׂ
        Node* find = visualScene->getNode( nodeId );
        if( find ) {

            return find;

        }

        // qȉ
        const int nodeNumber = visualScene->mNodes.size();
        for( int i=0; i<nodeNumber; i++ ) {

            Node* node = visualScene->mNodes[ i ];
            find = findNode( node, nodeId );
            if( find ) {

                return find;

            }

        }

        return NULL;

    }
}
