// Copyright(C)SEGA 
#include "Collada/Variant.h"

#include <string>

using namespace std;

namespace Collada {

    // RXgN^
    Variant::Variant() : 
mVariantType( Variant::VariantType_FLOAT ),
mFloatValue( 0.0f ),
mIntValue( 0 ),
mBoolValue( false )
{
}

// Float̒lݒ
void Variant::setFloatValue( const float value ) 
{
    mVariantType = VariantType_FLOAT;
    mFloatValue = value;
}

// Int̒lݒ
void Variant::setIntValue( const int value ) 
{
    mVariantType = VariantType_INT;
    mIntValue = value;    
}

// Bool̒lݒ
void Variant::setBoolValue( const bool value ) {

    mVariantType = VariantType_BOOL;
    mBoolValue = value;

}

// ̒lݒ
void Variant::setStringValue( const string& value ) {

    mVariantType = VariantType_STRING;
    mStringValue = value;        

}

// J[̒lݒ
void Variant::setColorValue( const Color& value ) {

    mVariantType = VariantType_COLOR;
    mColorValue = value;            

}

// operator==
bool Variant::operator==( const Variant& v ) const
{
    if( mVariantType != v.mVariantType ) {

        return false;

    }

    switch( mVariantType ) {

        case VariantType_FLOAT:
            if( mFloatValue != v.mFloatValue ) {

                return false;

            }
            break;

        case VariantType_INT:
            if( mIntValue != v.mIntValue ) {

                return false;

            }
            break;

        case VariantType_BOOL:
            if( mBoolValue != v.mBoolValue ) {

                return false;

            }
            break;

        case VariantType_STRING:
            if( mStringValue != v.mStringValue ) {

                return false;

            }
            break;

        case VariantType_COLOR:
            if( mColorValue != v.mColorValue ) {

                return false;

            }
            break;

    }

    return true;
}

// operator!=
bool Variant::operator!=( const Variant& v ) const
{
    return ( *this == v ) ? false : true;
}

}
