// Copyright(C)SEGA 
#include "Collada/VertexWeights.h"
#include "Collada/Util.h"
#include "Collada/StructVector.h"
#include "Collada/Macro.h"
#include "Collada/XML.h"

#include <sstream>
using namespace std;

namespace Collada {

    // fXgN^
    VertexWeights::~VertexWeights()
    {
        const int vNumber = mIndices.size();
        for( int i=0; i<vNumber; i++ ) {

            SAFE_DELETE( mIndices[ i ] );

        }
        mIndices.clear();
    }

    // XMLݒ
    void VertexWeights::toXML( XMLElement* e )
    {
        e->mName = "vertex_weights";        
        e->mAttributes.push_back( new XMLAttribute( "count", mVCounts.size() ) );
        {
            // input
            const int inputNumber = mInputs.size();
            for( int i=0; i<inputNumber; i++ ) {

                XMLElement* inputE = new XMLElement();

                inputE->mName = "input";                
                inputE->mAttributes.push_back( new XMLAttribute( "semantic", Util::getSemanticStr( mInputs[ i ].mSemantic ) ) );
                inputE->mAttributes.push_back( new XMLAttribute( "source", mInputs[ i ].mSource ) );
                inputE->mAttributes.push_back( new XMLAttribute( "offset", mInputs[ i ].mOffset ) );

                e->mChildren.push_back( inputE );

            }

            // vcount
            {
                ostringstream ss;

                const int vcountNumber = mVCounts.size();
                for( int i=0; i<vcountNumber; i++ ) {

                    if( i+1 != vcountNumber ) {

                        ss << mVCounts[ i ] << " ";

                    }
                    else {

                        ss << mVCounts[ i ];

                    }

                }

                XMLElement* vcountE = new XMLElement();
                vcountE->mName = "vcount";
                vcountE->mValue = ss.str();
                e->mChildren.push_back( vcountE );

            }

            // CfbNX(v)
            // offsetƂɕĎ
            {
                ostringstream ss;
                if( mIndices.size() != 0 ) {

                    const size_t num = mIndices[ 0 ]->getCount();

                    for( unsigned i=0; i<num; i++ ) {

                        const int vNumber = mIndices.size();
                        for( int vv=0; vv<vNumber; vv++ ) {

                            ss << mIndices[ vv ]->mElement[ i ] << " ";

                        }

                    }

                }
                XMLElement* vE = new XMLElement();

                vE->mName = "v";
                vE->mValue = ss.str();

                e->mChildren.push_back( vE );
            }

        }

    }

}