// Copyright(C)SEGA 
#include "Collada/VisualScene.h"
#include "Collada/Macro.h"
#include "Collada/Node.h"
#include "Collada/XML.h"

#include <string>
using namespace std;

namespace Collada {

    // fXgN^
    VisualScene::~VisualScene() {

        for( unsigned i=0; i<mNodes.size(); i++ ) {

            SAFE_DELETE( mNodes[ i ] );

        }
        mNodes.clear();

    }

    // m[h̎擾
    Node* VisualScene::getNode( const string& id ) 
    {
        const int nodeNumber = mNodes.size();
        for( int i=0; i<nodeNumber; i++ ) {

            if( mNodes[ i ]->mId == id ) {

                return	mNodes[ i ];

            }

        }

        return	NULL;

    }

    // XMLݒ
    void VisualScene::toXML( XMLElement* e )
    {
        e->mName = "visual_scene";        
        e->mAttributes.push_back( new XMLAttribute( "id", mId ) );
        e->mAttributes.push_back( new XMLAttribute( "name", mName ) );                
        {
            const int nodeNumber = mNodes.size();
            for( int i=0; i<nodeNumber; i++ ) {

                XMLElement* nodeE = new XMLElement();
                mNodes[ i ]->toXML( nodeE );
                e->mChildren.push_back( nodeE );

            }
        }
    }

}
