// Copyright(C)SEGA 
#include "Collada/XML.h"

#include <sstream>
#include <fstream>
#include <iostream>

using namespace std;

namespace Collada {

    // RXgN^(string)
    XMLAttribute::XMLAttribute( const string& n, const string& v ) : mName( n ), mValue( v ) 
    {
    }

    // RXgN^(int)
    XMLAttribute::XMLAttribute( const string& n, const int v ) : mName( n ) {

        std::ostringstream ss;
        ss << v;

        mValue = ss.str();

    }

    // fXgN^
    XMLElement::~XMLElement() 
    {
        const int attributesNumber = mAttributes.size();
        for( int i=0; i<attributesNumber; i++ ) {

            delete mAttributes[ i ];
            mAttributes[ i ] = NULL;

        }
        const int childrenNumber = mChildren.size();
        for( int i=0; i<childrenNumber; i++ ) {

            delete mChildren[ i ];
            mChildren[ i ] = NULL;

        }
    }

    // RXgN^
    XMLDocument::XMLDocument() : mRootElement( NULL ) {}

    // fXgN^
    XMLDocument::~XMLDocument() {

        delete mRootElement;
        mRootElement = NULL;

    }

    // t@CXg[փCfgo
    static void writeIndent( const int indent, ofstream& os )
    {
        for( int i=0; i<indent; i++ ) {

            os << "\t";

        }
    }	

    // t@CXg[֏o
    static void writeElement( XMLElement* e, const int indent, ofstream& os )
    {
        // ŏ"<HOGE"
        writeIndent( indent, os ); 
        os << "<" << e->mName;

        // Agr[g
        const int attributeNumber = e->mAttributes.size();
        for( int i=0; i<attributeNumber; i++ ) {

            os << " " << e->mAttributes[ i ]->mName << "=\"" << e->mAttributes[ i ]->mValue << "\"";

        }

        // l邩AqĂH
        if( e->mValue.size() > 0 || e->mChildren.size() > 0 ) {

            // q̏ꍇ͉s
            if( e->mChildren.size() > 0 ) {

                // ŏ">"
                os << ">" << endl;

                // l
                if( e->mValue.size() > 0 ) {

                    os << e->mValue << endl;

                }

                // q
                const int childrenNumber = e->mChildren.size();
                for( int i=0; i<childrenNumber; i++ ) {

                    writeElement( e->mChildren[ i ], indent+1, os );

                }

                // Ō"</HOGE>
                writeIndent( indent, os );
                os << "</" << e->mName << ">" << endl;

            }
            // qȂ̂Ƃ͉sȂ
            else {

                // ŏ">"
                os << ">";

                // l
                if( e->mValue.size() > 0 ) {

                    os << e->mValue;

                }

                // q
                const int childrenNumber = e->mChildren.size();
                for( int i=0; i<childrenNumber; i++ ) {

                    writeElement( e->mChildren[ i ], indent+1, os );

                }

                // Ō"</HOGE>
                os << "</" << e->mName << ">" << endl;

            }

        }
        // łȂƂ<HOGE/>Ƃ`ɂȂ
        else {

            os << "/>" << endl;

        }
    }

    // o
    bool XMLDocument::save( const string& filename )
    {
        ofstream os( filename.c_str() );
        if( !os.is_open() ) {

            cout << "err: can not open file = " << filename << endl;
            return false;

        }

        if( !mRootElement ) {

            return false;
            cout << "err: root is empty." << endl;

        }

        // t@CXg[֏o
        writeElement( mRootElement, 0, os );

        return true;
    }

};
