// Copyright(C)SEGA 
#ifndef	COLLADA_EXPORTER_CEGEOMETRY_H
#define	COLLADA_EXPORTER_CEGEOMETRY_H

namespace Collada {

    struct Float3;
    class Geometry;

}

#include <xsi_sceneitem.h>
#include <xsi_geometry.h>
#include <xsi_geometryaccessor.h>
#include <xsi_x3dobject.h>
#include <xsi_operator.h>
#include <xsi_envelopeweight.h>

#include <string>

/// WIg擾NX
class CEGeometry {

public:
    // RXgN^
    CEGeometry() {}

    // WIg擾
    bool get( XSI::SceneItem& sceneItem );

protected:
    // ʒu擾
    void getPositions( XSI::CGeometryAccessor& ga, Collada::Geometry* colladaGeometry );

    // @擾
    void getNormals( XSI::CGeometryAccessor& ga, Collada::Geometry* colladaGeometry );

    // _J[擾ij
    void getVertexColors( XSI::CGeometryAccessor& ga, Collada::Geometry* colladaGeometry );

    // UV擾ij
    void getUVs( XSI::CGeometryAccessor& ga, Collada::Geometry* colladaGeometry );

    // ڐ擾ij
    void getTangents( XSI::CGeometryAccessor& ga,
        Collada::Geometry* colladaGeometry );

    // ]@擾ij
    void getBinormals( XSI::CGeometryAccessor& ga,
        Collada::Geometry* colladaGeometry );

    // PolyList擾
    void getPolyLists( XSI::CGeometryAccessor& ga,
        Collada::Geometry* colladaGeometry );

    // Vertices擾
    void getVertices( Collada::Geometry* colladaGeometry );

    // Gx[v̐ݒύX
    void muteEnvelope( XSI::X3DObject& x3DObject,
        const bool enableMuts );					   

    // clusterȂUVAj擾
    void getUVTransform( XSI::Geometry& geometry );

    // NX^[ɑTextureProjection擾
    void getTextureProjections( XSI::Cluster& cluster,
        XSI::CRefArray& textureProjections );

    // TextureProjection炻ɕRTextureProjectionDef擾
    void getTextureProjectionDefs( const XSI::Property& textureProjection,
        XSI::Primitive& textureProjectionDef );

    // WIgǉ
    bool addGeometry( XSI::X3DObject x3DObject,
        const XSI::siConstructionMode mode,
        const bool shapeMode,
        const std::string& shapeName );

};

#endif	// COLLADA_EXPORTER_CEGEOMETRY_H
