// Copyright(C)SEGA 
#ifndef COLLADA_EXPORTER_CEOBJECT_H
#define COLLADA_EXPORTER_CEOBJECT_H

#include <string>
#include <vector>

#include <xsi_sceneitem.h>

namespace Collada {

    class Node;
    class VisualScene;

}

// m[h擾NX
class CEObject {

public:
    // m[h擾
    bool get();

    // IuWFNg_EFCg̑ΏۂǂԂ
    bool isWeightTarget( const std::string& name );

protected:
    // eqlĊi[
    void addNode( std::vector< Collada::Node* >& nodeArray,
        std::vector< std::string >& parentNameArray,
        Collada::VisualScene* visualScene );

    // IuWFNg̏ڍׂ擾
    bool getObjectInfo( XSI::SceneItem& sceneItem,
        Collada::Node* cfNode,
        std::string* parent );

    // Cg擾
    bool getLight( XSI::SceneItem& sceneItem,
        Collada::Node* cfNode );

    // J擾
    bool getCamera( XSI::SceneItem& sceneItem,
        Collada::Node* cfNode );

    // WIg擾
    bool getGeometry( XSI::SceneItem& sceneItem,
        Collada::Node* cfNode );

    // SRT擾
    bool getSRT( XSI::SceneItem& sceneItem,
        const bool local,
        Collada::Node* cfNode );

};

#endif // COLLADA_EXPORTER_CEOBJECT_H