// Copyright(C)SEGA 
#ifndef COLLADA_EXPORTER_CESYSTEM_H
#define COLLADA_EXPORTER_CESYSTEM_H

#include <vector>
#include <xsi_parameter.h>

namespace Collada {

    class Collection;

}

class CEOption;
class CEObject;
class CEGeometry;
class CETexture;

struct ParameterSet {

    // p[^̐e
    XSI::CRef mParent;

    // p[^
    XSI::Parameter mParameter;	

};

// GNX|[^[̃CVXe
// ĩf[^ułj
class CESystem {

public:
    // RXgN^
    CESystem();

    // fXgN^
    ~CESystem();

    // CX^X擾
    static void	createInstance();

    // CX^Xj
    static void	destroyInstance();

    // CX^X擾
    static CESystem* get();

    // Collection폜
    void clearCollection();

    // 
    bool initialize();

    // ColladaCollectionԂ
    Collada::Collection* getCollection();

    // ZNgXgNA
    void clearSelection();

    // ZNgXg擾
    XSI::CRefArray getSelection();

    // ZNgXgɒǉ
    void addSelection( XSI::CRef& ref );

    // ZNgXgɓĂ邩ׂ
    bool isSelect( XSI::CRef& ref ) const;

    // Ajp[^[擾
    XSI::CParameterRefArray getAnimatedParameter();

    // p[^[̐e擾ii[Ă΁j
    XSI::CRef getParameterParent( XSI::Parameter& parameter );

    // V[̏擾
    bool getScene();

    // wb_擾
    bool getHeader();

    // WIg擾NXԂ
    CEGeometry* getCEGeometry();

    // Colladaŏo
    bool write( const std::string& fileName );

    // eNX`wtH_ɃRs[
    bool copyTexture( const std::string& texturePath );

    // Rs[eNX`Xgɒǉ
    void addCopyTexture( const std::string& filename );

    // IvVԂ
    CEOption* getOption();

private:
    // AZbg擾
    void getAsset( const std::string& option );

    // Collada
    Collada::Collection* mCollection;

    // 擾IuWFNg̃Xg
    XSI::CRefArray mRefArraySelection;

    // p[^ƐẽZbgArray
    std::vector< ParameterSet* > mParameterSetArray;

    // eNX`t@C̃Zbg
    std::vector< std::string > mCopyTextureArray;

    // WIg擾NX
    CEGeometry* mGeometry;

    // IuWFNg擾NX
    CEObject* mObject;

    // IvV
    CEOption* mOption;

    /// CX^X
    static CESystem* mInstance;

};

#endif	// COLLADA_EXPORTER_CESYSTEM_H
