// Copyright(C)SEGA 
#ifndef COLLADA_EXPORTER_CEUTIL_H
#define COLLADA_EXPORTER_CEUTIL_H

#include <xsi_group.h>
#include <xsi_imageclip2.h>
#include <xsi_shader.h>

#include <string>
#include <xsi_string.h>
#include <xsi_cluster.h>
#include <xsi_primitive.h>
#include <xsi_mixer.h>
#include <xsi_transformation.h>

namespace Collada {

    struct Float3;
    struct Float4;
    struct Color;
    class Extra;
    class ExtraAttribute;
    struct Matrix;

}


class CEUtil {

public:
    // p[^ẽ}eA擾
    static void getMaterialByParameter( XSI::Parameter& parameter,
        XSI::Material& material );

    // p[^eImageClip擾
    static void getImageClipByParameter( XSI::Parameter& parameter,
        XSI::ImageClip2& imageClip );

    // ~LT[擾
    static void getMixer( XSI::SIObject& siObject,
        XSI::Mixer& mixer );

    // Gx[ṽoCh̃}gbNX擾
    static bool getBindMatrix( XSI::X3DObject& x3DObject, Collada::Matrix* cfMatrix );

    // Gx[ṽoChInverse}gbNX擾
    static bool getInvBindMatrix( XSI::X3DObject& x3DObject, Collada::Matrix* cfMatrix );

    // ̒u
    static void replaceChar( std::string* buffer,
        const char c1,
        const char c2 );

    // l01͈̔͂ɂ							 
    static void setRange0To1( float* value );

    // gXtH[[V擾
    static XSI::MATH::CTransformation getTransformation( XSI::SceneItem& sceneItem );

    // IuWFNgCMatrix擾
    static bool getCMatrix( XSI::SceneItem& sceneItem,
        const bool local,
        XSI::MATH::CMatrix4& matrix );

    // IuWFNgInvMatrix擾
    static bool getInvMatrix( XSI::SceneItem& sceneItem,
        const bool local,
        Collada::Matrix* cfMatrix );

    // IuWFNgMatrix擾
    static bool getMatrix( XSI::SceneItem& sceneItem,
        const bool local,
        Collada::Matrix* cfMatrix );

    // XSIMatrixColladaMatrixɕϊ
    static void CMatrixToColladaMatrix( const XSI::MATH::CMatrix4& matrix,
        Collada::Matrix* cfMatrix );

    // IuWFNgSRT擾
    static bool getSRT( XSI::SceneItem& sceneItem,
        const bool local,	
        Collada::Float3* scale,    
        Collada::Float4* rotationX,
        Collada::Float4* rotationY,
        Collada::Float4* rotationZ,
        Collada::Float3* translation );

    // IuWFNgSQT擾
    static bool getSQT( XSI::SceneItem& sceneItem,
        const bool local,	
        Collada::Float3* scale,    
        Collada::Float4* quaternion,
        Collada::Float3* translation,
        const double frame = DBL_MAX );


    // xNgFloat3^ŕԂ
    static Collada::Float3 getVector3d( XSI::MATH::CVector3& vector3 );

    // Scene_RootǂԂ
    static bool isSceneRoot( XSI::SIObject& SIObj );

    // RootɂIuWFNgǂԂ
    static bool isRootObject( XSI::SIObject&	object );

    // 擾IuWFNg̃XgNA
    static void clearSelectList();

    // 擾IuWFNg̃Xg
    static bool createSelectList();

    // ZNgXg̎q̂ȂŃu`Î̂擾
    static void getBranchItem( XSI::CRefArray& branchArray );

    // ׂĂ̎q擾
    static void getAllChildren( XSI::ProjectItem& parent,
        XSI::CRefArray& childArray );

    // J[p[^擾
    static bool getRGBValue( XSI::Parameter& param,
        Collada::Color* color );

    // 擾IuWFNgH
    static bool isGetObject( XSI::SceneItem&	sceneItem );

    // SceneItem擾Ώۂ̃^Cvׂ
    static bool checkType( XSI::SceneItem& sceneItem );

    // [g܂ł̂ǂꂩȂH(܂)
    static bool getRootVisibility( XSI::SceneItem&	checkSceneItem,
        bool& rootVisibility );

    // ^sԂ擾
    static bool getVisibility( XSI::SceneItem&	sceneItem,
        bool& visibility );

    // HideԂ擾
    static bool getHide( XSI::SceneItem& sceneItem,
        bool* hide );

    // C[̏ԂԂ
    static bool getLayer( XSI::ProjectItem&	projectItem,
        bool& visibleLayer );

    // Root܂ł̃pXԂ
    static void getRootPath( XSI::SIObject& object, std::string* path );

    // Properties(CRefArray)JX^p[^擾
    static bool getCustomParameterByProperties( XSI::CRefArray& properties,
        Collada::Extra* cfExtra );

    // PropertyJX^p[^擾
    static bool getCustomParameterByProperty( XSI::Property& property,
        Collada::Extra* cfExtra );

    // ParameterArrayJX^p[^擾
    static bool getCustomParameterByParameterArray( XSI::CParameterRefArray& parameterArray,
        const std::string& prefix,
        Collada::Extra* cfExtra );

    // ParameterJX^p[^擾
    static bool getCustomParameterByParameter( XSI::CParameterRefArray& parameterArray,
        XSI::Parameter& param,
        XSI::CString& paramName,
        Collada::ExtraAttribute* extraAttribute );

    // ImageClipJX^p[^擾
    static bool getCustomParameterByImageClip( XSI::ImageClip2&	imageClip,
        Collada::Extra* cfExtra );

    // MaterialJX^p[^擾
    static bool getCustomParameterByMaterial( XSI::Material& material,
        Collada::Extra* cfExtra );

    // SceneItemJX^p[^擾
    static bool getCustomParameterBySceneItem( XSI::SceneItem& sceneItem,
        Collada::Extra* cfExtra );

};



#endif // COLLADA_EXPORTER_CEUTIL_H