// Copyright(C)SEGA 
#include "FileIO/Path.h"
#include <windows.h>

#include <string>
#include <sstream>

using namespace std;

#pragma comment(lib, "imagehlp.lib")
#pragma comment(lib, "shlwapi.lib")

namespace FileIO {

    // ̒u֐
    static void replaceChar( string* str,
        const char target,
        const char replace )
    {
        const int len = str->size();
        for( int i=0; i<len; i++ ) {

            if( (*str)[ i ] == target ) {

                (*str)[ i ] = replace;

            }

        }
    }

    // ֋؂蕶؂蕶ɒupX쐬
    void Path::getReplaceDirectorySeparatorPath( const string& path,
        string* newpath )
    {
        *newpath = path;
        replaceChar( newpath, Path::getAltDirectorySeparatorChar(), Path::getDirectorySeparatorChar() );
    }

    // w肵pX̃fBNg擾
    void Path::getDirectoryName( const string& path, string* newpath )
    {
        string temp;
        getReplaceDirectorySeparatorPath( path, &temp );

        const int pos = temp.rfind( getDirectorySeparatorChar() );
        if( pos == -1 ) {

            ostringstream ss;
            ss << "." << getDirectorySeparatorChar();
            *newpath = ss.str();

        }
        else {

            *newpath = path.substr( 0, pos );

        }
    }

    // w肵pX̃t@CƊgq擾
    void Path::getFileName( const string& path, string* newpath )
    {
        string temp;
        getReplaceDirectorySeparatorPath( path, &temp );

        const int pos = temp.rfind( getDirectorySeparatorChar() );
        if( pos == -1 ) {

            *newpath = temp;

        }
        else {

            *newpath = temp.substr( pos + 1, temp.size() - pos - 1 );

        }
    }

    // w肵pX̃t@CgqtɎ擾
    void Path::getFileNameWithoutExtension( const string& path, string* newpath )
    {
        string filename;
        getFileName( path, &filename );

        const int pos = filename.rfind( "." );
        if( pos == -1 ) {

            *newpath = path;

        }
        else {

            *newpath = filename.substr( 0, pos );

        }
    }

    // fBNgԂ̋؂֕擾
    char Path::getAltDirectorySeparatorChar()
    {
        return	'/';
    }

    // fBNgԂ̋؂蕶擾
    char Path::getDirectorySeparatorChar()
    {
        return	'\\';
    }
};
